'   Prozeduren: Cvt_numerisch_to_DBF und Cvt_numerisch_from_DBF

' Version 3.0  26.3.2002.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka    
'                       email: gerhard-putschalka@gmx.at
'                    homepage: http://www.gerhard-putschalka.xprofan.com/index.htm

' Beschreibung der Prozeduren in CvDbNum.prf

Proc Cvt_numerisch_to_DBF
   Parameters Zx$,Lo%,Do%
   Declare Ganz$,Dezi$,Ix%,Iy%,Rc%,Ret$,Sign$,Zw$
   Zx$ = @Trim$(Zx$)
   Ganz$ = ""
   Dezi$ = ""
   Sign$ = ""
   Rc%   = 0
   Zx$ = @Trim$(@Translate$(Zx$,".","")) ' entferne Punkte und ussere Leerstellen   
   Zw$ = @Translate$(Zx$,",","") ' entferne testhalber Komma(s)
   Ix% = (@Len(Zx$) - @Len(Zw$))
   If (Ix% > 1)   ' mehr als 1 Komma eingegeben - beende mit Return = 4
      Ret$ = "4;0"
      Return Ret$
   EndIf
   ' hier ist der eingegebene Wert ohne ussere Leerstellen, ohne Punkte und hat max.
   ' ein Komma enthalten
   Ganz$ = @Substr$(Zx$,1,",") ' lse ganze Stellen
   Dezi$ = @Substr$(Zx$,2,",") ' lse Dezimalstellen (wenn vorhanden)
   ' nun drfen in Ganz$ und Dezi$ nur Ziffern sein (1. Stelle in Ganz$ darf auch "-" sein
   Ix% = @Len(Ganz$)
   Iy% = 1
   If (@Left$(Ganz$,1)="-")
      Iy% = 2 ' Minus, prfe ab 2. Stelle
      Case (@Len(Ganz$) = 1) : Ganz$ = "-0"
   Else
      Case (@Len(Ganz$) = 0) : Ganz$ = "0"
   EndIf

   Case (@Left$(Ganz$,1)="-") : Iy% = 2 ' Minus, prfe ab 2. Stelle
   WhileNot (Iy% > Ix%)
      Case (@Mid$(Ganz$,Iy%,1)<"0") | (@Mid$(Ganz$,Iy%,1)>"9") : Rc% = 9     
      Inc Iy%
   EndWhile
      
   Ix% = @Len(Dezi$)
   Iy% = 1
   WhileNot (Iy% > Ix%)
      Case (@Mid$(Dezi$,Iy%,1)<"0") | (@Mid$(Dezi$,Iy%,1)>"9") : Rc% = 9
      Inc Iy%
   EndWhile   

   If (Rc% = 9)    ' ungltige Zeichen entdeckt - beende
      Ret$ = "9;0"
      Return Ret$
   EndIf   

   ' prfe Ganze Stellen auf zu viele oder zu wenige Zeichen
   Ix% = Lo%
   Case (Do% > 0) : Ix% = (Lo% - Do% - 1) ' Ix% = Soll: Anzahl ganze Stellen
   If (@Len(Ganz$) > Ix%)
      Rc% = 2                    ' zu viele Stellen eingegeben
      Ganz$ = @Right$(Ganz$,Ix%)
   ElseIf (@Len(Ganz$) < Ix%)        ' zuwenige Stellen, flle mit fhr. Leerstellen auf
      Ix% = (Ix% - @Len(Ganz$))
      Ganz$ = Space$(Ix%);Ganz$
   EndIf

   ' prfe Dezimalstellen auf zu viele oder zu wenige Zeichen
   Ix% = Do%
   If (@Len(Dezi$) > Do%)
      Rc% = (Rc% + 1)            ' zu viele Stellen eingegeben
      Dezi$ = @Left$(Dezi$,Do%)  ' schneide rechts ab
   ElseIf (@Len(Dezi$) < Do%)        ' zuwenige Stellen, flle mit endenden Nullen auf
      Ix% = (Do% - @Len(Dezi$))
      Dezi$ = Dezi$;@MkStr$("0",Ix%)
   EndIf   

   Case (@Len(Dezi$) > 0) : Dezi$ = ".";Dezi$
   Ret$ = @Str$(Rc%);";";Ganz$;Dezi$
   Return Ret$
EndProc
'___________________________________________________________________________________
Proc Cvt_numerisch_from_DBF
   Parameters Zw$,Sep$
   Declare Ga$,De$,Sg$,Lg%,Ga&
   Zw$ = @Trim$(Zw$)
   Ga$ = @Substr$(Zw$,1,".")  ' extrahiere ganze Stellen
   De$ = @Substr$(Zw$,2,".")  ' extrahiere Dezimalstellen
   Lg% = @Len(Ga$)
   If (Sep$=".")         ' trifft zu, wenn Tausenderpunkte einzufgen sind
      Ga& = @Int(Ga$)
      Ga$ = @Format$("###,###,###,###,##0",Ga&)
   EndIf
   Ga$ = "0;";Ga$
   If (@Len(De$) > 0)
      Zw$ = Ga$;",";De$
   Else
      Zw$ = Ga$
   EndIf
   Return Zw$
EndProc
 