' QDatum.Inc  Prozeduren: Prfe-Datum und Setze-Datum

' Eine Beschreibung befindet sich in QDatum.prf

' Die 2. Prozedur (Setze_Datum) wandelt das Datum JJJJMMTT in TT.MM.JJJJ um.

' Version 1.1  26.2.2001.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka    
'                       email: gerhard-putschalka@gmx.at
'                    homepage: http://www.gerhard-putschalka.xprofan.com/index.htm

Proc Prfe_Datum
'---------------
   Parameters Zw$
   ' Das Datumsfeld (Param. 1) wird in der Form TTMMJJJJ (auch mit Punkten aufbe-
   ' reitet) erwartet. Die Rckgabe erfolgt in der Form: XJJJJMMTT ohne Aufbereitung.
   ' X ist der Returncode: 0 : kein Datum eingegeben
   '                       1 bis 3 : nur JJJJ oder JJJJMM oder JJJJMMTT eingegeben
   '                       9 : Datum ist fehlerhaft
   Declare ILen%,Nbr%,Zx$,Anz%,Ix%,Zy&,TT$,MM$,JJ$,TT%,MM%,JJ&,Zy$,W&,Mo$

   ' initialisiere Variable fr Tage im Monat (kein Array. Wrde beim stndigen Wiederaufruf
	' immer wieder neu definiert werden!). Ein Array ist immer global.
   Mo$ = "312831303130313130313031"
   Nbr%  = 0
   Anz% =  0
   TT$ = "  "
   MM$ = "  "
   JJ$ = "    "

   ILen% = @Len(Zw$)                ' Feldlnge
   ' Ist Eingabe leer, setze Returncode "0" und beende die Prozedur
   If (ILen%=0)                 ' wenn Null, setze Return und beende
      Zw$ = "0"
      Return Zw$
   EndIf
   ' prfe ob Datum aufbereitet ist, zhle Anzahl Punkte in Nbr%
   Ix% = 1
   WhileNot (Ix% > ILen%)
      Zx$ = @Mid$(Zw$,Ix%,1)
      Case (Zx$=".") : Inc Nbr%
      Inc Ix%
   EndWhile
   ' Fehler, wenn mehr als 2 Punkte gefunden wurden
   If (Nbr% > 2)
      Zw$ = "9        "         ' setze Fehlercode
      Return Zw$                    '   und beende
   EndIf
   ' lse aufbereitetes Datum (Tag, Monat Jahr) in Einzelfelder auf
   If (Nbr% = 2)
      TT$ = @Substr$(Zw$,1,".")
      MM$ = @Substr$(Zw$,2,".")
      JJ$ = @Substr$(Zw$,3,".")
      Anz% = 3
   ElseIf (Nbr% = 1)
      MM$ = @Substr$(Zw$,1,".")
      JJ$ = @Substr$(Zw$,2,".")
      Anz% = 2
   EndIf
   ' korrigiere Tag Monat, wenn nur einstellig
   Case (@Len(MM$) = 1) : MM$ = "0";MM$
   Case (@Len(TT$) = 1) : TT$ = "0";TT$
   Case (Nbr% > 0) : ZY$ = JJ$;MM$;TT$

   ' Tag und Monat darf max. je 2 Stellen enthalten, Jahr mu 4 Stellen lang sein,
   ' das Datumsfeld mu mindestens 4 Stellen lang sein.
   If (@Len(TT$) > 2) or (@Len(MM$) > 2) or (@Len(JJ$) > 4) \
                      or (@Len(JJ$) < 4) or (ILen% < 4)
      Zw$ = "9        "  ' setze Fehlercode
      Return Zw$             '   und beende
   EndIf
   ' bei 2 Punkten mu nun das Datum 8 Stellen haben, bei einem Punkt 6 Stellen
   If (Nbr% = 2) and (@Len(Zy$) < 8) or ((Nbr% = 1) and (@Len(Zy$) < 6))
      Zw$ = "9        "  ' setze Fehlercode
      Return Zw$             '   und beende
   EndIf

   ' Verarbeiten eines nicht aufbereiteten Datums
   ' Das Datum wird jetzt als JJJJMMTT (oder JJJJMM oder JJJJ) in Zy$ gestellt.
   ' Anz% zeigt an wieviele Werte (Jahr, Monat und Tag) gefunden wurden
   If (Nbr% = 0)
      If (ILen% = 4)
         Zy$ = @Right$(Zw$,4)
         Anz% = 1
      ElseIf (ILen% = 5)
         ZY$ = @Right$(Zw$,4);"0";@Mid$(Zw$,1,1)
         Anz% = 2
      ElseIf (ILen% = 6)
         Zy$ = @Right$(Zw$,4);@Mid$(Zw$,1,2)
         Anz% = 2
      ElseIf (ILen% = 7)
         Zy$ = @Right$(Zw$,4);@Mid$(Zw$,2,2);"0";@Mid$(Zw$,1,1)
         Anz% = 3
      ElseIf (ILen% = 8)
         Zy$ = @Right$(Zw$,4);@Mid$(Zw$,3,2);@Mid$(Zw$,1,2)
         Anz% = 3
      ElseIf (ILen% > 8)
         Zy$ = "        "
         Anz% = 9
      EndIf
   EndIf
   If (Anz% = 9)
      Zw$ = "9        "  ' setze Fehlercode
      Return Zw$             '   und beende
   EndIf
   ' das Datum ist jetzt formal richtig. Prfe auf Gltigkeit.
   JJ& = @Val(@Mid$(Zy$,1,4))
   If (Anz% > 1) and (Anz% < 4)
      MM% = @Val(@Mid$(Zy$,5,2))
      Case (MM% > 12) or (MM% < 1) : Anz% = 9 ' Monat nicht 1 bis 12
   EndIf

   If (Anz% = 3)
      TT% = @Val(@Mid$(Zy$,7,2))
      Case (TT% < 1)               : Anz% = 9 ' Tag < 1
      IfNot (MM% = 2)
         If (TT% > @Val(@Mid$(Mo$,MM%,2)))
            Anz% = 9                          ' Tag > als im Monat mglich
         EndIf
      Else                                    ' prfe fr Februar
         MM% = 28
         W& = (JJ& MOD 4)
         Case (W& = 0)                    : MM% = 29 'Schaltjahr
         Case (@Mid$(Zy$,3,2)="00")   : MM% = 28 ' .. nicht bei Jahrhundert (xx00)
         Case (@Mid$(Zy$,2,3)="000") : MM% = 29 ' .. aber bei Jahrtausend  (x000)
         Case (TT% > MM%)                 : Anz% = 9 ' Fehler
      EndIf
   EndIf
   Ix% = (8 - @Len(Zy$))
   Case (Ix% > 0) : Zy$ = Zy$;@Space$(Ix%)
   Zy$ = @Str$(Anz%);Zy$
   Return Zy$
EndProc
' ==================================================================
Proc Setze_Datum ' Datum JJJJMMTT in der Form TT.MM.JJJJ zurckgeben
'                      (JJJJMM als MM.JJJJ und JJJJ als JJJJ)
'---------------
' Ist das Feld leer ist die Laenge des Ergebnisfeldes Null.
   Parameters Zw$
   Zw$ = @Trim$(Zw$)
   If (@Len(Zw$)>6)
      Zw$ = @Mid$(Zw$,7,2);".";@Mid$(Zw$,5,2);".";@Mid$(Zw$,1,4)
   ElseIf (@Len(Zw$)>4)
      Zw$ = @Mid$(Zw$,5,2);".";@Mid$(Zw$,1,4)
   EndIf
   Return Zw$
EndProc
 